/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 102
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 102
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern34 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern34 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!const_compl_high_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern55 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern55 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V1SImode:
      if (pattern55 (x1, 
E_V1SImode) != 0)
        return -1;
      return 2;

    case E_V2HImode:
      if (pattern55 (x1, 
E_V2HImode) != 0)
        return -1;
      return 3;

    case E_V4QImode:
      if (pattern55 (x1, 
E_V4QImode) != 0)
        return -1;
      return 4;

    case E_V1DImode:
      if (pattern55 (x1, 
E_V1DImode) != 0)
        return -1;
      return 5;

    case E_V2SImode:
      if (pattern55 (x1, 
E_V2SImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern55 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8QImode:
      if (pattern55 (x1, 
E_V8QImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern91 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_or_zero_operand (operands[0], i1)
      || !arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !symbolic_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !register_or_zero_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case LABEL_REF:
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC
          || !comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_CCFPmode:
          if (!fcc_register_operand (operands[0], E_CCFPmode))
            return -1;
          return 103; /* *normal_fp_branch */

        case E_CCFPEmode:
          if (!fcc_register_operand (operands[0], E_CCFPEmode))
            return -1;
          return 105; /* *normal_fpe_branch */

        default:
          return -1;
        }

    case PC:
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC
          || !comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_CCFPmode:
          if (!fcc_register_operand (operands[0], E_CCFPmode))
            return -1;
          return 104; /* *inverted_fp_branch */

        case E_CCFPEmode:
          if (!fcc_register_operand (operands[0], E_CCFPEmode))
            return -1;
          return 106; /* *inverted_fpe_branch */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[3] = x4;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!icc_or_fcc_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      if (!icc_or_fcc_register_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 2);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern126 (x2, 
E_QImode) != 0
              || !
#line 2836 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && !(QImode == DImode && TARGET_ARCH32)))
            return -1;
          return 158; /* *movqi_cc_v9 */

        case E_HImode:
          if (pattern126 (x2, 
E_HImode) != 0
              || !
#line 2836 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && !(HImode == DImode && TARGET_ARCH32)))
            return -1;
          return 159; /* *movhi_cc_v9 */

        case E_SImode:
          if (pattern126 (x2, 
E_SImode) != 0
              || !
#line 2836 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && !(SImode == DImode && TARGET_ARCH32)))
            return -1;
          return 160; /* *movsi_cc_v9 */

        case E_DImode:
          if (pattern126 (x2, 
E_DImode) != 0
              || !
#line 2836 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && !(DImode == DImode && TARGET_ARCH32)))
            return -1;
          return 161; /* *movdi_cc_v9 */

        case E_SFmode:
          if (pattern127 (x2, 
E_SFmode) != 0
              || !
#line 2858 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
            return -1;
          return 166; /* *movsf_cc_v9 */

        case E_DFmode:
          if (pattern127 (x2, 
E_DFmode) != 0
              || !
#line 2881 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
            return -1;
          return 168; /* movdf_cc_v9 */

        case E_TFmode:
          if (pattern127 (x2, 
E_TFmode) != 0
              || !
#line 2906 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 170; /* *movtf_cc_hq_v9 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[0] = x4;
      if (REGNO (x2) == 100)
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          switch (GET_MODE (x2))
            {
            case E_CCmode:
              if (GET_MODE (x3) == E_CCmode
                  && register_operand (operands[0], E_SImode)
                  && arith_operand (operands[1], E_SImode))
                return 1; /* *cmpsi_insn */
              break;

            case E_CCXmode:
              if (GET_MODE (x3) == E_CCXmode
                  && register_operand (operands[0], E_DImode)
                  && arith_operand (operands[1], E_DImode)
                  && 
#line 671 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return 2; /* *cmpdi_sp64 */
              break;

            default:
              break;
            }
        }
      operands[1] = x4;
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode))
        {
          x5 = XEXP (x3, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && REGNO (x2) == 100)
            {
              switch (GET_MODE (x2))
                {
                case E_CCmode:
                  if (GET_MODE (x3) == E_CCmode)
                    return 182; /* *cmp_zero_qi */
                  break;

                case E_CCXmode:
                  if (GET_MODE (x3) == E_CCXmode
                      && 
#line 3207 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return 186; /* *cmp_zero_qi_sp64 */
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_CODE (x4) != SUBREG)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x2) != 100
          || GET_MODE (x2) != E_CCmode
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      switch (SUBREG_BYTE (x4))
        {
        case 3:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 189; /* *cmp_siqi_trunc */

        case 7:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 3256 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 191; /* *cmp_diqi_trunc */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[0] = x6;
          switch (XWINT (x5, 0))
            {
            case -1L:
              switch (GET_MODE (x2))
                {
                case E_CCCmode:
                  if (GET_MODE (x3) != E_CCCmode
                      || GET_MODE (x4) != E_SImode
                      || !arith_operand (operands[0], E_SImode))
                    return -1;
                  return 3; /* *cmpsi_sne */

                case E_CCXCmode:
                  if (GET_MODE (x3) != E_CCXCmode
                      || GET_MODE (x4) != E_DImode
                      || !arith_operand (operands[0], E_DImode)
                      || !
#line 687 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 4; /* *cmpdi_sne */

                default:
                  return -1;
                }

            case 0L:
              switch (GET_MODE (x2))
                {
                case E_CCmode:
                  if (GET_MODE (x3) != E_CCmode
                      || GET_MODE (x4) != E_SImode
                      || !arith_operand (operands[0], E_SImode))
                    return -1;
                  return 345; /* *cmp_cc_not */

                case E_CCXmode:
                  if (GET_MODE (x3) != E_CCXmode
                      || GET_MODE (x4) != E_DImode
                      || !arith_operand (operands[0], E_DImode)
                      || !
#line 5970 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 346; /* *cmp_ccx_not */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case XOR:
          if (XWINT (x5, 0) != 0L)
            return -1;
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          x8 = XEXP (x6, 1);
          operands[1] = x8;
          switch (GET_MODE (x2))
            {
            case E_CCmode:
              if (pattern104 (x3, 
E_SImode, 
E_CCmode) != 0)
                return -1;
              return 318; /* *cmp_cc_xor_not */

            case E_CCXmode:
              if (pattern104 (x3, 
E_DImode, 
E_CCXmode) != 0
                  || !
#line 5577 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 319; /* *cmp_ccx_xor_not */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_CCmode:
          if (GET_MODE (x3) != E_CCmode
              || GET_MODE (x4) != E_SImode)
            return -1;
          return 181; /* *cmp_zero_extendqisi2 */

        case E_CCXmode:
          if (GET_MODE (x3) != E_CCXmode
              || GET_MODE (x4) != E_DImode
              || !
#line 3199 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 185; /* *cmp_zero_extendqidi2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      if (!small_int_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 2);
      operands[2] = x10;
      if (!small_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_CCmode:
          if (GET_MODE (x3) != E_CCmode
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !
#line 3470 "../../gcc/config/sparc/sparc.md"
(INTVAL (operands[2]) > 19))
            return -1;
          return 199; /* *cmp_zero_extract */

        case E_CCXmode:
          if (GET_MODE (x3) != E_CCXmode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !
#line 3487 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && INTVAL (operands[2]) > 51))
            return -1;
          return 200; /* *cmp_zero_extract_sp64 */

        default:
          return -1;
        }

    case PLUS:
      if (REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != 0L)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_CCNZmode:
              if (pattern90 (x3, 
E_SImode, 
E_CCNZmode) != 0)
                return -1;
              return 226; /* *cmp_ccnz_plus */

            case E_CCXNZmode:
              if (pattern90 (x3, 
E_DImode, 
E_CCXNZmode) != 0
                  || !
#line 4011 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 227; /* *cmp_ccxnz_plus */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x5, operands[0]))
            return -1;
          switch (GET_MODE (x2))
            {
            case E_CCCmode:
              if (pattern90 (x3, 
E_SImode, 
E_CCCmode) != 0)
                return -1;
              return 230; /* *cmp_ccc_plus */

            case E_CCXCmode:
              if (pattern90 (x3, 
E_DImode, 
E_CCXCmode) != 0
                  || !
#line 4051 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 231; /* *cmp_ccxc_plus */

            default:
              return -1;
            }

        case UNSPEC:
          switch (pattern74 (x1, 
62))
            {
            case 0:
              if (pattern124 (x3, 
E_SImode, 
E_CCVmode) != 0)
                return -1;
              return 235; /* *cmp_ccv_plus */

            case 1:
              if (pattern124 (x3, 
E_DImode, 
E_CCXVmode) != 0
                  || !
#line 4110 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 236; /* *cmp_ccxv_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != 0L)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_CCNZmode:
              if (pattern91 (x3, 
E_SImode, 
E_CCNZmode) != 0)
                return -1;
              return 247; /* *cmp_ccnz_minus */

            case E_CCXNZmode:
              if (pattern91 (x3, 
E_DImode, 
E_CCXNZmode) != 0
                  || !
#line 4431 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 248; /* *cmp_ccxnz_minus */

            default:
              return -1;
            }

        case UNSPEC:
          switch (pattern74 (x1, 
63))
            {
            case 0:
              if (pattern125 (x3, 
E_SImode, 
E_CCVmode) != 0)
                return -1;
              return 254; /* *cmp_ccv_minus */

            case 1:
              if (pattern125 (x3, 
E_DImode, 
E_CCXVmode) != 0
                  || !
#line 4514 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 255; /* *cmp_ccxv_minus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      switch (GET_MODE (x2))
        {
        case E_CCmode:
          if (pattern92 (x3, 
E_SImode, 
E_CCmode) == 0)
            return 314; /* *cmp_cc_arith_op */
          break;

        case E_CCXmode:
          if (pattern92 (x3, 
E_DImode, 
E_CCXmode) == 0
              && 
#line 5531 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return 315; /* *cmp_ccx_arith_op */
          break;

        default:
          break;
        }
      switch (GET_CODE (operands[2]))
        {
        case AND:
        case IOR:
          if (GET_CODE (x6) != NOT)
            return -1;
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          operands[1] = x9;
          switch (GET_MODE (x2))
            {
            case E_CCmode:
              if (pattern114 (x3, 
E_SImode, 
E_CCmode) != 0)
                return -1;
              return 322; /* *cmp_cc_arith_op_not */

            case E_CCXmode:
              if (pattern114 (x3, 
E_DImode, 
E_CCXmode) != 0
                  || !
#line 5621 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 323; /* *cmp_ccx_arith_op_not */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      if (REGNO (x2) != 100)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != 0L)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_CCNZmode:
              if (GET_MODE (x3) != E_CCNZmode
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode))
                return -1;
              return 331; /* *cmp_ccnz_neg */

            case E_CCXNZmode:
              if (GET_MODE (x3) != E_CCXNZmode
                  || GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !
#line 5834 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 332; /* *cmp_ccxnz_neg */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 64)
            return -1;
          x11 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x11, operands[0]))
            return -1;
          switch (GET_MODE (x2))
            {
            case E_CCVmode:
              if (pattern105 (x3, 
E_SImode, 
E_CCVmode) != 0)
                return -1;
              return 338; /* *cmp_ccv_neg */

            case E_CCXVmode:
              if (pattern105 (x3, 
E_DImode, 
E_CCXVmode) != 0
                  || !
#line 5906 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 339; /* *cmp_ccxv_neg */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x2) != 100
          || GET_MODE (x2) != E_CCNZmode
          || GET_MODE (x3) != E_CCNZmode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 391; /* *cmp_ccnz_ashift_1 */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !input_operand (operands[2], E_SImode)
          || !
#line 5183 "../../gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_DEPRECATED_V8_INSNS) && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 1;
      return 291; /* divsi3_sp32 */

    case E_DImode:
      if (pattern32 (x3, 
E_DImode) != 0
          || !
#line 5228 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 293; /* divdi3 */

    case E_TFmode:
      if (pattern10 (x3, 
E_TFmode) != 0
          || !
#line 6212 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
        return -1;
      return 370; /* *divtf3_hq */

    case E_DFmode:
      if (pattern10 (x3, 
E_DFmode) != 0)
        return -1;
      if (
#line 6227 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
        return 371; /* *divdf3_nofix */
      if (!
#line 6236 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && sparc_fix_ut699))
        return -1;
      return 372; /* *divdf3_fix */

    case E_SFmode:
      if (pattern10 (x3, 
E_SFmode) != 0
          || !
#line 6246 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
        return -1;
      return 373; /* divsf3 */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != SUBREG
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_MODE (x7) != E_CCmode
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (SUBREG_BYTE (x8))
    {
    case 3:
      if (maybe_ne (SUBREG_BYTE (x6), 3)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 190; /* *cmp_siqi_trunc_set */

    case 7:
      if (maybe_ne (SUBREG_BYTE (x6), 7)
          || !register_operand (operands[1], E_DImode)
          || !
#line 3266 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 192; /* *cmp_diqi_trunc_set */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_SImode))
    {
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != COMPARE)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  operands[1] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern136 (x2, 
E_CCmode, 
E_SImode) != 0)
        return -1;
      return 349; /* *cmp_cc_set */

    case E_DImode:
      if (pattern136 (x2, 
E_CCXmode, 
E_DImode) != 0
          || !
#line 6008 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 350; /* *cmp_ccx_set64 */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case NEG:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NE:
          switch (pattern48 (x3))
            {
            case 0:
              if (!(
#line 864 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_SUBXC) && 
#line 866 "../../gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                return NULL;
              return gen_split_9 (insn, operands);

            case 1:
              if (!((
#line 864 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_SUBXC) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 866 "../../gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                return NULL;
              return gen_split_10 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          switch (pattern48 (x3))
            {
            case 0:
              if (!(
#line 931 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64) && 
#line 933 "../../gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                return NULL;
              return gen_split_19 (insn, operands);

            case 1:
              if (!(
#line 931 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64) && 
#line 933 "../../gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                return NULL;
              return gen_split_20 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (pattern14 (x3))
            {
            case 0:
              if (!(
#line 6266 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 6268 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_83 (insn, operands);

            case 1:
              if (!(
#line 6307 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9) && 
#line 6309 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_84 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          switch (GET_CODE (x3))
            {
            case NE:
              switch (pattern4 (x3))
                {
                case 0:
                  if ((
#line 837 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_VIS3) && 
#line 839 "../../gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                    return gen_split_5 (insn, operands);
                  break;

                case 1:
                  if (((
#line 837 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_VIS3) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 839 "../../gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                    return gen_split_6 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case EQ:
              switch (pattern4 (x3))
                {
                case 0:
                  if ((
#line 917 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64) && 
#line 919 "../../gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                    return gen_split_17 (insn, operands);
                  break;

                case 1:
                  if ((
#line 917 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64) && 
#line 919 "../../gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                    return gen_split_18 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x3;
      operands[2] = x4;
      if (!icc_register_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !icc_comparison_operator (operands[1], E_SImode)
              || !
#line 1350 "../../gcc/config/sparc/sparc.md"
(TARGET_V9
   /* 64-bit LTU is better implemented using addxc with VIS3.  */
   && !(GET_CODE (operands[1]) == LTU
	&& (GET_MODE (operands[2]) == CCXmode
	    || GET_MODE (operands[2]) == CCXCmode)
	&& TARGET_VIS3)
   /* 32-bit LTU/GEU are better implemented using addx/subx.  */
   && !((GET_CODE (operands[1]) == LTU || GET_CODE (operands[1]) == GEU)
	&& (GET_MODE (operands[2]) == CCmode
	    || GET_MODE (operands[2]) == CCCmode))))
            return NULL;
          return gen_split_41 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !icc_comparison_operator (operands[1], E_DImode)
              || !(
#line 1350 "../../gcc/config/sparc/sparc.md"
(TARGET_V9
   /* 64-bit LTU is better implemented using addxc with VIS3.  */
   && !(GET_CODE (operands[1]) == LTU
	&& (GET_MODE (operands[2]) == CCXmode
	    || GET_MODE (operands[2]) == CCXCmode)
	&& TARGET_VIS3)
   /* 32-bit LTU/GEU are better implemented using addx/subx.  */
   && !((GET_CODE (operands[1]) == LTU || GET_CODE (operands[1]) == GEU)
	&& (GET_MODE (operands[2]) == CCmode
	    || GET_MODE (operands[2]) == CCCmode))) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return NULL;
          return gen_split_42 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && 
#line 2118 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && ((GET_CODE (operands[0]) == REG
        && SPARC_INT_REG_P (REGNO (operands[0])))
       || (GET_CODE (operands[0]) == SUBREG
           && GET_CODE (SUBREG_REG (operands[0])) == REG
           && SPARC_INT_REG_P (REGNO (SUBREG_REG (operands[0])))))))
            return gen_split_43 (insn, operands);
          if (!memory_operand (operands[0], E_DImode)
              || !const_zero_operand (operands[1], E_DImode)
              || !
#line 2185 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && !mem_min_alignment (operands[0], 8)))
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_47 (insn, operands);

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || !const_zero_operand (operands[1], E_TImode)
              || !
#line 2278 "../../gcc/config/sparc/sparc.md"
(reload_completed))
            return NULL;
          return gen_split_49 (insn, operands);

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !fp_const_high_losum_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../gcc/config/sparc/sparc.md"
(REG_P (operands[0]) && SPARC_INT_REG_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_52 (insn, operands);

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode))
            {
              if (const_double_operand (operands[1], E_DFmode)
                  && 
#line 2517 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && REG_P (operands[0])
   && SPARC_INT_REG_P (REGNO (operands[0]))
   && !const_zero_operand (operands[1], GET_MODE (operands[0]))))
                return gen_split_53 (insn, operands);
              if (const_zero_operand (operands[1], E_DFmode)
                  && 
#line 2561 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && ((GET_CODE (operands[0]) == REG
	&& SPARC_INT_REG_P (REGNO (operands[0])))
       || (GET_CODE (operands[0]) == SUBREG
	   && GET_CODE (SUBREG_REG (operands[0])) == REG
	   && SPARC_INT_REG_P (REGNO (SUBREG_REG (operands[0])))))))
                return gen_split_54 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DFmode)
              || !const_zero_operand (operands[1], E_DFmode)
              || !
#line 2615 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && !mem_min_alignment (operands[0], 8)))
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_58 (insn, operands);

        case E_TFmode:
          if (!nonimmediate_operand (operands[0], E_TFmode)
              || !const_zero_operand (operands[1], E_TFmode)
              || !
#line 2714 "../../gcc/config/sparc/sparc.md"
(reload_completed))
            return NULL;
          return gen_split_60 (insn, operands);

        case E_V1DImode:
          if (!memory_operand (operands[0], E_V1DImode)
              || !const_zero_operand (operands[1], E_V1DImode)
              || !
#line 8558 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_100 (insn, operands);

        case E_V2SImode:
          if (!memory_operand (operands[0], E_V2SImode)
              || !const_zero_operand (operands[1], E_V2SImode)
              || !
#line 8558 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_101 (insn, operands);

        case E_V4HImode:
          if (!memory_operand (operands[0], E_V4HImode)
              || !const_zero_operand (operands[1], E_V4HImode)
              || !
#line 8558 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_102 (insn, operands);

        case E_V8QImode:
          if (!memory_operand (operands[0], E_V8QImode)
              || !const_zero_operand (operands[1], E_V8QImode)
              || !
#line 8558 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_103 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (register_operand (operands[0], E_DImode))
            {
              if (register_operand (operands[1], E_DImode)
                  && 
#line 2146 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
           && sparc_split_reg_reg_legitimate (operands[0], operands[1])))))
                return gen_split_44 (insn, operands);
              if (memory_operand (operands[1], E_DImode)
                  && 
#line 2161 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_45 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 2173 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_46 (insn, operands);

        case E_TImode:
          if (register_operand (operands[0], E_TImode))
            {
              if (register_operand (operands[1], E_TImode)
                  && 
#line 2243 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && ((TARGET_FPU
        && !TARGET_HARD_QUAD)
       || (!fp_register_operand (operands[0], TImode)
           && !fp_register_operand (operands[1], TImode)))))
                return gen_split_48 (insn, operands);
              if (memory_operand (operands[1], E_TImode)
                  && 
#line 2306 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && offsettable_memref_p (operands[1])
   && (!TARGET_HARD_QUAD
       || !fp_register_operand (operands[0], TImode))))
                return gen_split_50 (insn, operands);
            }
          if (!memory_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2340 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && offsettable_memref_p (operands[0])
   && (!TARGET_HARD_QUAD
       || !fp_register_operand (operands[1], TImode))))
            return NULL;
          return gen_split_51 (insn, operands);

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode))
            {
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 2578 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))))
                return gen_split_55 (insn, operands);
              if (memory_operand (operands[1], E_DFmode)
                  && 
#line 2591 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_56 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode)
              || !
#line 2603 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_57 (insn, operands);

        case E_TFmode:
          if (register_operand (operands[0], E_TFmode))
            {
              if (register_operand (operands[1], E_TFmode)
                  && 
#line 2678 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && (TARGET_ARCH32
       || (TARGET_FPU
           && !TARGET_HARD_QUAD)
       || (!fp_register_operand (operands[0], TFmode)
           && !fp_register_operand (operands[1], TFmode)))))
                return gen_split_59 (insn, operands);
              if (memory_operand (operands[1], E_TFmode)
                  && 
#line 2742 "../../gcc/config/sparc/sparc.md"
((reload_completed
    && offsettable_memref_p (operands[1])
    && (TARGET_ARCH32
	|| !TARGET_HARD_QUAD
	|| !fp_register_operand (operands[0], TFmode)))))
                return gen_split_61 (insn, operands);
            }
          if (!memory_operand (operands[0], E_TFmode)
              || !register_operand (operands[1], E_TFmode)
              || !
#line 2777 "../../gcc/config/sparc/sparc.md"
((reload_completed
    && offsettable_memref_p (operands[0])
    && (TARGET_ARCH32
	|| !TARGET_HARD_QUAD
	|| !fp_register_operand (operands[1], TFmode)))))
            return NULL;
          return gen_split_62 (insn, operands);

        case E_V1DImode:
          if (register_operand (operands[0], E_V1DImode))
            {
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 8519 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_88 (insn, operands);
              if (memory_operand (operands[1], E_V1DImode)
                  && 
#line 8532 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_92 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V1DImode)
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 8545 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_96 (insn, operands);

        case E_V2SImode:
          if (register_operand (operands[0], E_V2SImode))
            {
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 8519 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_89 (insn, operands);
              if (memory_operand (operands[1], E_V2SImode)
                  && 
#line 8532 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_93 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V2SImode)
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 8545 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_97 (insn, operands);

        case E_V4HImode:
          if (register_operand (operands[0], E_V4HImode))
            {
              if (register_operand (operands[1], E_V4HImode)
                  && 
#line 8519 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_90 (insn, operands);
              if (memory_operand (operands[1], E_V4HImode)
                  && 
#line 8532 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_94 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V4HImode)
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 8545 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_98 (insn, operands);

        case E_V8QImode:
          if (register_operand (operands[0], E_V8QImode))
            {
              if (register_operand (operands[1], E_V8QImode)
                  && 
#line 8519 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_91 (insn, operands);
              if (memory_operand (operands[1], E_V8QImode)
                  && 
#line 8532 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_95 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V8QImode)
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 8545 "../../gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_99 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      if (GET_MODE (x3) != E_TFmode)
        return NULL;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[1] = x4;
          if (icc_or_fcc_comparison_operator (operands[1], E_VOIDmode))
            {
              x6 = XEXP (x4, 1);
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  && register_operand (operands[0], E_TFmode))
                {
                  x7 = XEXP (x4, 0);
                  operands[2] = x7;
                  if (icc_or_fcc_register_operand (operands[2], E_VOIDmode))
                    {
                      x5 = XEXP (x3, 1);
                      operands[3] = x5;
                      if (register_operand (operands[3], E_TFmode))
                        {
                          x8 = XEXP (x3, 2);
                          operands[4] = x8;
                          if (register_operand (operands[4], E_TFmode)
                              && (
#line 2928 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 2930 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                            return gen_split_63 (insn, operands);
                        }
                    }
                }
            }
          if (!v9_register_comparison_operator (operands[1], E_VOIDmode))
            return NULL;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_TFmode))
            return NULL;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_TFmode))
            return NULL;
          x8 = XEXP (x3, 2);
          operands[4] = x8;
          if (!register_operand (operands[4], E_TFmode)
              || !(
#line 2968 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 2970 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_64 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !(
#line 3147 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3149 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_65 (insn, operands);

        case PLUS:
          if (pattern51 (x4, 
PLUS) != 0)
            return NULL;
          x7 = XEXP (x4, 0);
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!arith_operand (operands[2], E_SImode)
              || !(
#line 3917 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3919 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_69 (insn, operands);

        case MINUS:
          if (pattern51 (x4, 
MINUS) != 0)
            return NULL;
          x7 = XEXP (x4, 0);
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return NULL;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!arith_operand (operands[2], E_SImode)
              || !(
#line 4332 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4334 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_74 (insn, operands);

        default:
          return NULL;
        }

    case ABS:
      switch (pattern14 (x3))
        {
        case 0:
          if (!(
#line 6370 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 6372 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_85 (insn, operands);

        case 1:
          if (!(
#line 6411 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9) && 
#line 6413 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_86 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
