/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode)
          || !register_operand (operands[2], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!icc_register_operand (operands[1], E_VOIDmode))
    return -1;
  return pattern17 (x1); /* [-1, 1] */
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern22 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern22 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_CCmode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_CCXmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return pattern17 (x1); /* [-1, 1] */
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!icc_register_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern58 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern58 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  if (!symbolic_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern74 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_MODE (x6))
    {
    case E_CCVmode:
      return 0;

    case E_CCXVmode:
      return 1;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !arith_add_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (pattern10 (x1, 
E_TFmode) != 0)
        return -1;
      return 2;

    case E_DFmode:
      if (pattern10 (x1, 
E_DFmode) != 0)
        return -1;
      return 3;

    case E_SFmode:
      if (pattern10 (x1, 
E_SFmode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (pattern10 (x1, 
E_V1SImode) != 0)
        return -1;
      return 5;

    case E_V2SImode:
      if (pattern10 (x1, 
E_V2SImode) != 0)
        return -1;
      return 6;

    case E_V2HImode:
      if (pattern10 (x1, 
E_V2HImode) != 0)
        return -1;
      return 7;

    case E_V4HImode:
      if (pattern10 (x1, 
E_V4HImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (pattern10 (x1, 
E_V1DImode) != 0)
        return -1;
      return 9;

    case E_V8QImode:
      if (pattern10 (x1, 
E_V8QImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || !arith_add_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern133 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !arith_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_SImode
      || pattern159 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_CCFPEmode:
      switch (pattern73 (x3, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 695 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 5; /* *cmpsf_fpe */

        case 1:
          if (!
#line 707 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 6; /* *cmpdf_fpe */

        case 2:
          if (!
#line 720 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 7; /* *cmptf_fpe */

        default:
          return -1;
        }

    case E_CCFPmode:
      switch (pattern73 (x3, 
E_CCFPmode))
        {
        case 0:
          if (!
#line 732 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 8; /* *cmpsf_fp */

        case 1:
          if (!
#line 744 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 9; /* *cmpdf_fp */

        case 2:
          if (!
#line 757 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 10; /* *cmptf_fp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !immediate_operand (operands[1], E_SImode)
              || !
#line 1704 "../../gcc/config/sparc/sparc.md"
(!flag_pic))
            return -1;
          return 118; /* *movsi_high */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          if (medium_pic_operand (operands[1], E_DImode)
              && 
#line 1976 "../../gcc/config/sparc/sparc.md"
((TARGET_CM_MEDLOW || TARGET_CM_EMBMEDANY) && flag_pic && check_pic (1)))
            return 131; /* *sethi_di_medlow_embmedany_pic */
          if (!symbolic_operand (operands[1], E_DImode)
              || !
#line 1982 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDLOW && !flag_pic))
            return -1;
          return 132; /* *sethi_di_medlow */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !fp_const_high_losum_operand (operands[1], E_SFmode))
            return -1;
          return 152; /* *movsf_high */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          switch (XINT (x4, 1))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!
#line 1726 "../../gcc/config/sparc/sparc.md"
(flag_pic && check_pic (1)))
                    return -1;
                  return 120; /* movsi_high_pic */

                case 1:
                  if (!
#line 1947 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && flag_pic && check_pic (1)))
                    return -1;
                  return 129; /* movdi_high_pic */

                default:
                  return -1;
                }

            case 5:
              if (pattern69 (x3) != 0
                  || !
#line 1996 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDMID && !flag_pic))
                return -1;
              return 134; /* seth44 */

            case 7:
              if (pattern69 (x3) != 0
                  || !
#line 2018 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return -1;
              return 137; /* sethh */

            case 8:
              if (pattern69 (x3) != 0
                  || !
#line 2025 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return -1;
              return 138; /* setlm */

            case 9:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!data_segment_operand (operands[1], E_DImode)
                  || !
#line 2047 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 141; /* embmedany_sethi */

            case 10:
              if (pattern70 (x3) != 0
                  || !
#line 2068 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 144; /* embmedany_textuhi */

            case 11:
              if (pattern70 (x3) != 0
                  || !
#line 2075 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 145; /* embmedany_texthi */

            case 17:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tgd_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 7931 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 460; /* tgd_hi22si */

                case 1:
                  if (!(
#line 7931 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 461; /* tgd_hi22di */

                default:
                  return -1;
                }

            case 18:
              x5 = XVECEXP (x4, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 7967 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 468; /* tldm_hi22si */

                case 1:
                  if (!(
#line 7967 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 469; /* tldm_hi22di */

                default:
                  return -1;
                }

            case 19:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tld_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 8001 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 476; /* tldo_hix22si */

                case 1:
                  if (!(
#line 8001 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 477; /* tldo_hix22di */

                default:
                  return -1;
                }

            case 20:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tie_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 8025 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 482; /* tie_hi22si */

                case 1:
                  if (!(
#line 8025 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 483; /* tie_hi22di */

                default:
                  return -1;
                }

            case 21:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tle_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 8073 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 488; /* tle_hix22si */

                case 1:
                  if (!(
#line 8073 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 489; /* tle_hix22di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (XINT (x4, 1) != 4)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x4, 0, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern98 (x3, 
E_SImode) != 0
                  || !
#line 1782 "../../gcc/config/sparc/sparc.md"
(flag_pic))
                return -1;
              return 122; /* *movsi_high_pic_label_ref */

            case E_DImode:
              if (pattern98 (x3, 
E_DImode) != 0
                  || !
#line 1916 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && flag_pic))
                return -1;
              return 126; /* *movdi_high_pic_label_ref */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern67 (x3, 
E_DImode) != 0
              || !
#line 5502 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 312; /* *xor_not_di_sp64 */

        case E_SImode:
          if (pattern67 (x3, 
E_SImode) != 0)
            return -1;
          return 313; /* *xor_not_si */

        case E_V1SImode:
          if (pattern30 (x3, 
E_V1SImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 570; /* *not_xorv1si3 */

        case E_V2HImode:
          if (pattern30 (x3, 
E_V2HImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 573; /* *not_xorv2hi3 */

        case E_V4QImode:
          if (pattern30 (x3, 
E_V4QImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 576; /* *not_xorv4qi3 */

        case E_V1DImode:
          if (pattern30 (x3, 
E_V1DImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 579; /* *not_xorv1di3 */

        case E_V2SImode:
          if (pattern30 (x3, 
E_V2SImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 582; /* *not_xorv2si3 */

        case E_V4HImode:
          if (pattern30 (x3, 
E_V4HImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 585; /* *not_xorv4hi3 */

        case E_V8QImode:
          if (pattern30 (x3, 
E_V8QImode) != 0
              || !
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 588; /* *not_xorv8qi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !arith_operand (operands[1], E_DImode)
              || !
#line 5949 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 343; /* one_cmpldi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !arith_operand (operands[1], E_SImode))
            return -1;
          return 344; /* one_cmplsi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 624; /* one_cmplv1si2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 625; /* one_cmplv2hi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 626; /* one_cmplv4qi2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 627; /* one_cmplv1di2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 628; /* one_cmplv2si2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 629; /* one_cmplv4hi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 8652 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 630; /* one_cmplv8qi2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern31 (x3))
        {
        case 0:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 568; /* *not_iorv1si3 */

        case 1:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 571; /* *not_iorv2hi3 */

        case 2:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 574; /* *not_iorv4qi3 */

        case 3:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 577; /* *not_iorv1di3 */

        case 4:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 580; /* *not_iorv2si3 */

        case 5:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 583; /* *not_iorv4hi3 */

        case 6:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 586; /* *not_iorv8qi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern31 (x3))
        {
        case 0:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 569; /* *not_andv1si3 */

        case 1:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 572; /* *not_andv2hi3 */

        case 2:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 575; /* *not_andv4qi3 */

        case 3:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 578; /* *not_andv1di3 */

        case 4:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 581; /* *not_andv2si3 */

        case 5:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 584; /* *not_andv4hi3 */

        case 6:
          if (!
#line 8614 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 587; /* *not_andv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT
      || GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 8)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x9 = XVECEXP (x4, 0, 4);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x10 = XVECEXP (x4, 0, 5);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x11 = XVECEXP (x4, 0, 6);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x12 = XVECEXP (x4, 0, 7);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x13 = XEXP (x1, 0);
  operands[0] = x13;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x14 = XEXP (x3, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_V4QImode))
    return -1;
  x15 = XEXP (x3, 1);
  operands[2] = x15;
  if (!register_operand (operands[2], E_V4QImode)
      || !
#line 8709 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
    return -1;
  return 635; /* fpmerge_vis */
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      if (XINT (x3, 1) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern25 (x3, 
E_SImode) != 0
              || !
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return -1;
          return 436; /* probe_stack_rangesi */

        case E_DImode:
          if (pattern25 (x3, 
E_DImode) != 0
              || !
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 437; /* probe_stack_rangedi */

        default:
          return -1;
        }

    case 1:
      if (XINT (x3, 1) != 10
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !memory_operand (operands[0], E_SImode)
          || !
#line 7480 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
        return -1;
      return 446; /* stfsr */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern52 (x1, 
E_DImode) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 4670 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 264; /* mulsidi3_v8plus */

        case CONST_INT:
          operands[2] = x8;
          if (!small_int_operand (operands[2], E_DImode)
              || !
#line 4682 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 265; /* const_mulsidi3_v8plus */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 4872 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 275; /* umulsidi3_v8plus */

        case CONST_INT:
          operands[2] = x8;
          if (!uns_small_int_operand (operands[2], E_DImode)
              || !
#line 4936 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 280; /* const_umulsidi3_v8plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case NE:
          switch (pattern35 (x1))
            {
            case 0:
              return gen_split_1 (insn, operands);

            case 1:
              if (!(
#line 852 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 854 "../../gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_7 (insn, operands);

            case 2:
              if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_2 (insn, operands);

            case 3:
              if (!((
#line 852 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 854 "../../gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          switch (pattern38 (x1))
            {
            case 0:
              return gen_split_3 (insn, operands);

            case 1:
              if (!(
#line 879 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 881 "../../gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_11 (insn, operands);

            case 2:
              if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_4 (insn, operands);

            case 3:
              if (!((
#line 879 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 881 "../../gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_12 (insn, operands);

            case 4:
              return gen_split_15 (insn, operands);

            case 5:
              if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_16 (insn, operands);

            case 6:
              if (!(
#line 5714 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5716 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_80 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          switch (pattern39 (x1))
            {
            case 0:
              return gen_split_13 (insn, operands);

            case 1:
              if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_14 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 100)
            return NULL;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case NE:
              x8 = XEXP (x7, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern102 (x1))
                {
                case 0:
                  return gen_split_21 (insn, operands);

                case 1:
                  if (!(
#line 981 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 983 "../../gcc/config/sparc/sparc.md"
( 1)))
                    return NULL;
                  return gen_split_25 (insn, operands);

                case 2:
                  if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return NULL;
                  return gen_split_22 (insn, operands);

                case 3:
                  if (!((
#line 981 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 983 "../../gcc/config/sparc/sparc.md"
( 1)))
                    return NULL;
                  return gen_split_26 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              x9 = XEXP (x7, 0);
              if (GET_CODE (x9) != NE)
                return NULL;
              x10 = XEXP (x9, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern113 (x1))
                {
                case 0:
                  return gen_split_23 (insn, operands);

                case 1:
                  if (!(
#line 997 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 999 "../../gcc/config/sparc/sparc.md"
( 1)))
                    return NULL;
                  return gen_split_27 (insn, operands);

                case 2:
                  if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return NULL;
                  return gen_split_24 (insn, operands);

                case 3:
                  if (!((
#line 997 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 999 "../../gcc/config/sparc/sparc.md"
( 1)))
                    return NULL;
                  return gen_split_28 (insn, operands);

                default:
                  return NULL;
                }

            case EQ:
              x8 = XEXP (x7, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_SImode))
                return NULL;
              x11 = XEXP (x3, 1);
              operands[2] = x11;
              if (GET_MODE (x5) != E_CCmode)
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern140 (x3, 
E_SImode) != 0)
                    return NULL;
                  return gen_split_37 (insn, operands);

                case E_DImode:
                  if (pattern140 (x3, 
E_DImode) != 0
                      || !
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return NULL;
                  return gen_split_38 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x11 = XEXP (x3, 1);
              operands[2] = x11;
              if (!arith_double_operand (operands[2], E_DImode)
                  || GET_MODE (x5) != E_CCmode
                  || !(
#line 3816 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3818 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_66 (insn, operands);

            case ZERO_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || pattern103 (x3) != 0
                  || GET_MODE (x5) != E_CCmode
                  || !(
#line 3932 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3934 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_70 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          switch (pattern46 (x1))
            {
            case 0:
              return gen_split_29 (insn, operands);

            case 1:
              if (!(
#line 1045 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 1047 "../../gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_33 (insn, operands);

            case 2:
              if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_30 (insn, operands);

            case 3:
              if (!((
#line 1045 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 1047 "../../gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_34 (insn, operands);

            case 4:
              return gen_split_39 (insn, operands);

            case 5:
              if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_40 (insn, operands);

            case 6:
              if (!(
#line 4232 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4234 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_71 (insn, operands);

            case 7:
              if (!(
#line 4347 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4349 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_75 (insn, operands);

            case 8:
              return gen_split_31 (insn, operands);

            case 9:
              if (!(
#line 1061 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 1063 "../../gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_35 (insn, operands);

            case 10:
              if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_32 (insn, operands);

            case 11:
              if (!((
#line 1061 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 1063 "../../gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        case COMPARE:
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 100)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          x12 = XEXP (x4, 1);
          if (GET_MODE (x12) != E_DImode)
            return NULL;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case PLUS:
              if (GET_MODE (x7) != E_DImode
                  || GET_CODE (x12) != PLUS)
                return NULL;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x8 = XEXP (x7, 1);
              operands[2] = x8;
              if (!arith_double_operand (operands[2], E_DImode))
                return NULL;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return NULL;
              x14 = XEXP (x12, 1);
              if (!rtx_equal_p (x14, operands[2]))
                return NULL;
              x11 = XEXP (x3, 1);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x11, operands[1])
                      || GET_MODE (x6) != E_CCCmode
                      || GET_MODE (x3) != E_CCCmode
                      || !(
#line 3844 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3846 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                    return NULL;
                  return gen_split_67 (insn, operands);

                case UNSPEC:
                  if (XVECLEN (x11, 0) != 2
                      || XINT (x11, 1) != 62
                      || GET_MODE (x11) != E_DImode
                      || GET_MODE (x6) != E_CCVmode
                      || GET_MODE (x3) != E_CCVmode)
                    return NULL;
                  x15 = XVECEXP (x11, 0, 0);
                  if (!rtx_equal_p (x15, operands[1]))
                    return NULL;
                  x16 = XVECEXP (x11, 0, 1);
                  if (!rtx_equal_p (x16, operands[2])
                      || !(
#line 3882 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3884 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                    return NULL;
                  return gen_split_68 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_DImode)
                  || GET_CODE (x12) != MINUS
                  || GET_MODE (x6) != E_CCCmode
                  || GET_MODE (x3) != E_CCCmode)
                return NULL;
              x11 = XEXP (x3, 1);
              operands[2] = x11;
              if (!arith_double_operand (operands[2], E_DImode))
                return NULL;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return NULL;
              x14 = XEXP (x12, 1);
              if (!rtx_equal_p (x14, operands[2])
                  || !(
#line 4258 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4260 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_72 (insn, operands);

            case MINUS:
              if (GET_MODE (x7) != E_DImode)
                return NULL;
              x11 = XEXP (x3, 1);
              if (pattern123 (x11, 
E_DImode, 
63, 
2) != 0
                  || GET_CODE (x12) != MINUS
                  || GET_MODE (x6) != E_CCVmode
                  || GET_MODE (x3) != E_CCVmode)
                return NULL;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x8 = XEXP (x7, 1);
              operands[2] = x8;
              if (!arith_double_operand (operands[2], E_DImode)
                  || pattern142 (x1) != 0
                  || !(
#line 4298 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4300 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_73 (insn, operands);

            case NOT:
              if (GET_MODE (x7) != E_DImode)
                return NULL;
              x11 = XEXP (x3, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
                  || pattern131 (x1, 
E_CCCmode) != 0)
                return NULL;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1])
                  || !(
#line 5734 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5736 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_81 (insn, operands);

            case NEG:
              if (GET_MODE (x7) != E_DImode)
                return NULL;
              x11 = XEXP (x3, 1);
              if (pattern123 (x11, 
E_DImode, 
64, 
1) != 0
                  || pattern131 (x1, 
E_CCVmode) != 0)
                return NULL;
              x15 = XVECEXP (x11, 0, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return NULL;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1])
                  || !(
#line 5763 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5765 "../../gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_82 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          if (pattern47 (x1) != 0)
            return NULL;
          return gen_split_76 (insn, operands);

        case IOR:
          if (pattern47 (x1) != 0)
            return NULL;
          return gen_split_77 (insn, operands);

        case XOR:
          if (pattern47 (x1) != 0)
            return NULL;
          return gen_split_78 (insn, operands);

        case NOT:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != XOR
              || GET_MODE (x7) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x7, 1);
          operands[2] = x8;
          if (!const_compl_high_operand (operands[2], E_SImode))
            return NULL;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return NULL;
          return gen_split_79 (insn, operands);

        default:
          return NULL;
        }

    case SET:
      return split_1 (x1, insn);

    case EH_RETURN:
      if (!
#line 7194 "../../gcc/config/sparc/sparc.md"
(epilogue_completed))
        return NULL;
      return gen_split_87 (insn, operands);

    default:
      return NULL;
    }
}
