/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern10 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern10 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern10 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !register_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_CCmode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || GET_MODE (x1) != E_CCXmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode)
      || !register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !symbolic_operand (operands[1], i1)
      || !call_address_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  return pattern36 (x6); /* [-1, 1] */
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_or_zero_operand (operands[0], i1)
      || !arith_add_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !symbolic_operand (operands[1], i1)
      || !call_address_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_CCVmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_CCVmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_DImode:
          return 0;

        case E_SImode:
          return 1;

        default:
          return -1;
        }

    case E_CCXVmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_CCXVmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_add_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 23:
      if (pattern19 (x1, 
E_V4HImode, 
E_V4QImode) != 0
          || !
#line 8664 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 631; /* fpack16_vis */

    case 25:
      if (pattern19 (x1, 
E_V2SImode, 
E_V2HImode) != 0
          || !
#line 8674 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 632; /* fpackfix_vis */

    case 59:
      if (pattern20 (x1, 
E_V4QImode) != 0
          || !
#line 8721 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 636; /* fmul8x16_vis */

    case 27:
      if (pattern21 (x1, 
E_V4HImode) != 0
          || !
#line 8731 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 637; /* fmul8x16au_vis */

    case 28:
      if (pattern21 (x1, 
E_V4HImode) != 0
          || !
#line 8741 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 638; /* fmul8x16al_vis */

    case 60:
      if (pattern20 (x1, 
E_V8QImode) != 0
          || !
#line 8751 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 639; /* fmul8sux16_vis */

    case 29:
      if (pattern20 (x1, 
E_V8QImode) != 0
          || !
#line 8761 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 640; /* fmul8ulx16_vis */

    case 61:
      if (pattern21 (x1, 
E_V2SImode) != 0
          || !
#line 8771 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 641; /* fmuld8sux16_vis */

    case 30:
      if (pattern21 (x1, 
E_V2SImode) != 0
          || !
#line 8781 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 642; /* fmuld8ulx16_vis */

    case 39:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9057 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 704; /* array8si_vis */

        case 1:
          if (!(
#line 9057 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 705; /* array8di_vis */

        default:
          return -1;
        }

    case 40:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9066 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 706; /* array16si_vis */

        case 1:
          if (!(
#line 9066 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 707; /* array16di_vis */

        default:
          return -1;
        }

    case 41:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9075 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 708; /* array32si_vis */

        case 1:
          if (!(
#line 9075 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 709; /* array32di_vis */

        default:
          return -1;
        }

    case 44:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9132 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 716; /* edge8nsi_vis */

        case 1:
          if (!(
#line 9132 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 717; /* edge8ndi_vis */

        default:
          return -1;
        }

    case 45:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9141 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 718; /* edge8lnsi_vis */

        case 1:
          if (!(
#line 9141 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 719; /* edge8lndi_vis */

        default:
          return -1;
        }

    case 46:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9150 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 720; /* edge16nsi_vis */

        case 1:
          if (!(
#line 9150 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 721; /* edge16ndi_vis */

        default:
          return -1;
        }

    case 47:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9159 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 722; /* edge16lnsi_vis */

        case 1:
          if (!(
#line 9159 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 723; /* edge16lndi_vis */

        default:
          return -1;
        }

    case 48:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9168 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 724; /* edge32nsi_vis */

        case 1:
          if (!(
#line 9168 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 725; /* edge32ndi_vis */

        default:
          return -1;
        }

    case 49:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9177 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 726; /* edge32lnsi_vis */

        case 1:
          if (!(
#line 9177 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 727; /* edge32lndi_vis */

        default:
          return -1;
        }

    case 51:
      if (pattern24 (x1) != 0)
        return -1;
      if (register_or_zero_operand (operands[0], E_SImode)
          && (
#line 9187 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return 728; /* cmask8si_vis */
      if (!register_or_zero_operand (operands[0], E_DImode)
          || !(
#line 9187 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 729; /* cmask8di_vis */

    case 52:
      if (pattern24 (x1) != 0)
        return -1;
      if (register_or_zero_operand (operands[0], E_SImode)
          && (
#line 9197 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return 730; /* cmask16si_vis */
      if (!register_or_zero_operand (operands[0], E_DImode)
          || !(
#line 9197 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 731; /* cmask16di_vis */

    case 53:
      if (pattern24 (x1) != 0)
        return -1;
      if (register_or_zero_operand (operands[0], E_SImode)
          && (
#line 9207 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return 732; /* cmask32si_vis */
      if (!register_or_zero_operand (operands[0], E_DImode)
          || !(
#line 9207 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 733; /* cmask32di_vis */

    case 54:
      if (pattern20 (x1, 
E_V4HImode) != 0
          || !
#line 9217 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
        return -1;
      return 734; /* fchksm16_vis */

    case 55:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      switch (pattern4 (x2))
        {
        case 0:
          if (!(
#line 9244 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 743; /* pdistnsi_vis */

        case 1:
          if (!(
#line 9244 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 744; /* pdistndi_vis */

        default:
          return -1;
        }

    case 56:
      switch (pattern26 (x1))
        {
        case 0:
          if (!
#line 9409 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 781; /* fhaddsf_vis */

        case 1:
          if (!
#line 9418 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 782; /* fhadddf_vis */

        default:
          return -1;
        }

    case 57:
      switch (pattern26 (x1))
        {
        case 0:
          if (!
#line 9428 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 783; /* fhsubsf_vis */

        case 1:
          if (!
#line 9437 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 784; /* fhsubdf_vis */

        default:
          return -1;
        }

    case 65:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !imm5_operand_dictunpack8 (operands[2], E_SImode)
              || !
#line 9474 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
            return -1;
          return 787; /* dictunpack8 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !imm5_operand_dictunpack16 (operands[2], E_SImode)
              || !
#line 9474 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
            return -1;
          return 788; /* dictunpack16 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !imm5_operand_dictunpack32 (operands[2], E_SImode)
              || !
#line 9474 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
            return -1;
          return 789; /* dictunpack32 */

        default:
          return -1;
        }

    case 66:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XVECEXP (x2, 0, 1);
      operands[3] = x5;
      if (!imm2_operand (operands[3], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case EQ:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 790; /* fpcmpeq8sishl */

            case 1:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 794; /* fpcmpeq16sishl */

            case 2:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 798; /* fpcmpeq32sishl */

            case 3:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 802; /* fpcmpeq8dishl */

            case 4:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 806; /* fpcmpeq16dishl */

            case 5:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 810; /* fpcmpeq32dishl */

            default:
              return -1;
            }

        case NE:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 791; /* fpcmpne8sishl */

            case 1:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 795; /* fpcmpne16sishl */

            case 2:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 799; /* fpcmpne32sishl */

            case 3:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 803; /* fpcmpne8dishl */

            case 4:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 807; /* fpcmpne16dishl */

            case 5:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 811; /* fpcmpne32dishl */

            default:
              return -1;
            }

        case LE:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 792; /* fpcmple8sishl */

            case 1:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 796; /* fpcmple16sishl */

            case 2:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 800; /* fpcmple32sishl */

            case 3:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 804; /* fpcmple8dishl */

            case 4:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 808; /* fpcmple16dishl */

            case 5:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 812; /* fpcmple32dishl */

            default:
              return -1;
            }

        case GT:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 793; /* fpcmpgt8sishl */

            case 1:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 797; /* fpcmpgt16sishl */

            case 2:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 801; /* fpcmpgt32sishl */

            case 3:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 805; /* fpcmpgt8dishl */

            case 4:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 809; /* fpcmpgt16dishl */

            case 5:
              if (!(
#line 9486 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 813; /* fpcmpgt32dishl */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 67:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XVECEXP (x2, 0, 1);
      operands[3] = x5;
      if (!imm2_operand (operands[3], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case LEU:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 814; /* fpcmpule8sishl */

            case 1:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 816; /* fpcmpule16sishl */

            case 2:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 818; /* fpcmpule32sishl */

            case 3:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 820; /* fpcmpule8dishl */

            case 4:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 822; /* fpcmpule16dishl */

            case 5:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 824; /* fpcmpule32dishl */

            default:
              return -1;
            }

        case GTU:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 815; /* fpcmpugt8sishl */

            case 1:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 817; /* fpcmpugt16sishl */

            case 2:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 819; /* fpcmpugt32sishl */

            case 3:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 821; /* fpcmpugt8dishl */

            case 4:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 823; /* fpcmpugt16dishl */

            case 5:
              if (!(
#line 9497 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 825; /* fpcmpugt32dishl */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 15:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[1] = x5;
      if (zero_or_v7_operand (operands[1], E_SImode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          if (rtx_equal_p (x4, operands[0]))
            return 838; /* *membar_empty */
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 8L:
          if (
#line 63 "../../gcc/config/sparc/sync.md"
(TARGET_V8))
            return 839; /* *membar_storestore */
          break;

        case 2L:
          if (
#line 71 "../../gcc/config/sparc/sync.md"
(TARGET_V8))
            return 840; /* membar_storeload */
          break;

        default:
          break;
        }
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      if (
#line 89 "../../gcc/config/sparc/sync.md"
(TARGET_V8))
        return 841; /* *membar_v8 */
      if (!
#line 105 "../../gcc/config/sparc/sync.md"
(TARGET_V9))
        return -1;
      return 842; /* *membar */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return recog_16 (x1, insn, pnum_clobbers);

    case NE:
      return recog_29 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_18 (x1, insn, pnum_clobbers);

    case EQ:
      switch (pattern3 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 23; /* *seqsisi_zero */

        case 1:
          if (!
#line 917 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 27; /* *seqdisi_zero */

        case 2:
          if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 24; /* *seqsidi_zero */

        case 3:
          if (!
#line 917 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 28; /* *seqdidi_zero */

        case 4:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 668; /* fpcmpeq8si_vis */

        case 5:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 672; /* fpcmpeq16si_vis */

        case 6:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 676; /* fpcmpeq32si_vis */

        case 7:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 680; /* fpcmpeq8di_vis */

        case 8:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 684; /* fpcmpeq16di_vis */

        case 9:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 688; /* fpcmpeq32di_vis */

        default:
          return -1;
        }

    case LTU:
      switch (pattern5 (x1))
        {
        case 0:
          if (
#line 1106 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
            return 51; /* *sltusi_insn */
          if (!
#line 1168 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[1]) == CCXmode || GET_MODE (operands[1]) == CCXCmode)))
            return -1;
          return 64; /* *sltusi_insn_vis3 */

        case 1:
          if ((
#line 1106 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return 52; /* *sltudi_insn */
          if (!(
#line 1168 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[1]) == CCXmode || GET_MODE (operands[1]) == CCXCmode)) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 65; /* *sltudi_insn_vis3 */

        default:
          return -1;
        }

    case GEU:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1262 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
            return -1;
          return 83; /* *sgeusi_insn */

        case 1:
          if (!(
#line 1262 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 84; /* *sgeudi_insn */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_27 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_19 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_22 (x1, insn, pnum_clobbers);

    case LO_SUM:
      return recog_20 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 3503 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 201; /* extendsfdf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x2) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 3517 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 202; /* *extendsftf2_hq */

            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 3530 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 203; /* *extenddftf2_hq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 3537 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 204; /* truncdfsf2 */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !
#line 3552 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 205; /* *trunctfsf2_hq */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 3565 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 206; /* *trunctfdf2_hq */

        default:
          return -1;
        }

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern49 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 3575 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 207; /* floatsisf2 */

            case 1:
              if (!
#line 3612 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 210; /* floatdisf2 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern49 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 3583 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 208; /* floatsidf2 */

            case 1:
              if (!
#line 3626 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 211; /* floatdidf2 */

            default:
              return -1;
            }

        case E_TFmode:
          switch (pattern49 (x2, 
E_TFmode))
            {
            case 0:
              if (!
#line 3597 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 209; /* *floatsitf2_hq */

            case 1:
              if (!
#line 3646 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 212; /* *floatditf2_hq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      return recog_31 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_17 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_28 (x1, insn, pnum_clobbers);

    case UDIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !input_operand (operands[2], E_SImode))
            return -1;
          if (
#line 5270 "../../gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_DEPRECATED_V8_INSNS) && TARGET_ARCH32))
            return 295; /* udivsi3_sp32 */
          if (!
#line 5309 "../../gcc/config/sparc/sparc.md"
(TARGET_DEPRECATED_V8_INSNS && TARGET_ARCH64))
            return -1;
          return 296; /* udivsi3_sp64 */

        case E_DImode:
          if (pattern32 (x2, 
E_DImode) != 0
              || !
#line 5318 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 297; /* udivdi3 */

        default:
          return -1;
        }

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 5464 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 310; /* xordi3 */

        case 1:
          return 311; /* xorsi3 */

        case 2:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 549; /* xorv1si3 */

        case 3:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 552; /* xorv2hi3 */

        case 4:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 555; /* xorv4qi3 */

        case 5:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 558; /* xorv1di3 */

        case 6:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 561; /* xorv2si3 */

        case 7:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 564; /* xorv4hi3 */

        case 8:
          if (!
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 567; /* xorv8qi3 */

        default:
          return -1;
        }

    case NOT:
      return recog_21 (x1, insn, pnum_clobbers);

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern78 (x2, 
E_DFmode) != 0
                  || !
#line 6116 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 360; /* fmadf4 */

            case E_SFmode:
              if (pattern78 (x2, 
E_SFmode) != 0
                  || !
#line 6152 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 364; /* fmasf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern79 (x2, 
E_DFmode) != 0
                  || !
#line 6125 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 361; /* fmsdf4 */

            case E_SFmode:
              if (pattern79 (x2, 
E_SFmode) != 0
                  || !
#line 6161 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 365; /* fmssf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern6 (x1))
        {
        case 0:
          if (
#line 6363 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return 379; /* *abstf2_hq */
          if (!
#line 6370 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD))
            return -1;
          return 380; /* *abstf2 */

        case 1:
          if (
#line 6411 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9))
            return 381; /* *absdf2_notv9 */
          if (!
#line 6446 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_V9))
            return -1;
          return 382; /* *absdf2_v9 */

        case 2:
          if (!
#line 6454 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 383; /* abssf2 */

        default:
          return -1;
        }

    case SQRT:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 6467 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 384; /* *sqrttf2_hq */

        case 1:
          if (
#line 6480 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
            return 385; /* *sqrtdf2_nofix */
          if (!
#line 6488 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && sparc_fix_ut699))
            return -1;
          return 386; /* *sqrtdf2_fix */

        case 2:
          if (!
#line 6497 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
            return -1;
          return 387; /* sqrtsf2 */

        default:
          return -1;
        }

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern33 (x2))
        {
        case 0:
          return 388; /* ashlsi3 */

        case 1:
          if (register_operand (operands[1], E_DImode)
              && 
#line 6535 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return 389; /* *ashldi3_sp64 */
          if (pnum_clobbers == NULL
              || !arith_operand (operands[1], E_DImode)
              || !
#line 6548 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 1;
          return 390; /* ashldi3_v8plus */

        case 2:
          if (!
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 735; /* vashlv4hi3 */

        case 3:
          if (!
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 739; /* vashlv2si3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_23 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      if (pattern7 (x1) != 0
          || !
#line 6622 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && INTVAL (operands[2]) > 0 && INTVAL (operands[2]) <= 32))
        return -1;
      return 396; /* *ashrsi3_extend2 */

    case LSHIFTRT:
      return recog_25 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      if (pattern7 (x1) != 0
          || !
#line 6717 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && INTVAL (operands[2]) > 0 && INTVAL (operands[2]) <= 32))
        return -1;
      return 402; /* *lshrsi3_extend2 */

    case CALL:
      return recog_24 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_30 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SIGN_EXTEND:
          res = recog_9 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case HIGH:
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTEND:
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MULT:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_15 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (
#line 6828 "../../gcc/config/sparc/sparc.md"
(!TARGET_CBCOND))
                return 409; /* *jump_ubranch */
              if (
#line 6836 "../../gcc/config/sparc/sparc.md"
(TARGET_CBCOND))
                return 410; /* *jump_cbcond */
            }
          break;

        default:
          break;
        }
      operands[0] = x2;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != PC)
        return -1;
      if (address_operand (operands[0], E_SImode)
          && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return 440; /* *branchsi */
      if (!address_operand (operands[0], E_DImode)
          || !
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 441; /* *branchdi */

    case POPCOUNT:
      switch (pattern8 (x1))
        {
        case 0:
          if (
#line 7502 "../../gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH64))
            return 447; /* *popcountdi_sp64 */
          if (pnum_clobbers == NULL
              || !
#line 7509 "../../gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 448; /* popcountdi_v8plus */

        case 1:
          if (!
#line 7544 "../../gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH32))
            return -1;
          return 450; /* popcountsi_v8plus */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern8 (x1))
        {
        case 0:
          if (
#line 7568 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH64))
            return 451; /* *clzdi_sp64 */
          if (pnum_clobbers == NULL
              || !
#line 7576 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 452; /* clzdi_v8plus */

        case 1:
          if (!
#line 7617 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          return 454; /* clzsi_v8plus */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_26 (x1, insn, pnum_clobbers);

    case LE:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 670; /* fpcmple8si_vis */

        case 1:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 674; /* fpcmple16si_vis */

        case 2:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 678; /* fpcmple32si_vis */

        case 3:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 682; /* fpcmple8di_vis */

        case 4:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 686; /* fpcmple16di_vis */

        case 5:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 690; /* fpcmple32di_vis */

        default:
          return -1;
        }

    case GT:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 671; /* fpcmpgt8si_vis */

        case 1:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 675; /* fpcmpgt16si_vis */

        case 2:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 679; /* fpcmpgt32si_vis */

        case 3:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 683; /* fpcmpgt8di_vis */

        case 4:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 687; /* fpcmpgt16di_vis */

        case 5:
          if (!(
#line 8994 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 691; /* fpcmpgt32di_vis */

        default:
          return -1;
        }

    case LEU:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 692; /* fpcmpule8si_vis */

        case 1:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 694; /* fpcmpule16si_vis */

        case 2:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 696; /* fpcmpule32si_vis */

        case 3:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 698; /* fpcmpule8di_vis */

        case 4:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 700; /* fpcmpule16di_vis */

        case 5:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 702; /* fpcmpule32di_vis */

        default:
          return -1;
        }

    case GTU:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 693; /* fpcmpugt8si_vis */

        case 1:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 695; /* fpcmpugt16si_vis */

        case 2:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 697; /* fpcmpugt32si_vis */

        case 3:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 699; /* fpcmpugt8di_vis */

        case 4:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 701; /* fpcmpugt16di_vis */

        case 5:
          if (!(
#line 9021 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 703; /* fpcmpugt32di_vis */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern10 (x2, 
E_V4HImode) != 0
              || !
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 736; /* vssashlv4hi3 */

        case E_V2SImode:
          if (pattern10 (x2, 
E_V2SImode) != 0
              || !
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 740; /* vssashlv2si3 */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 750; /* ssaddv4hi3 */

        case 1:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 752; /* ssaddv2si3 */

        case 2:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 754; /* ssaddv2hi3 */

        case 3:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 756; /* ssaddv1si3 */

        case 4:
          if (!
#line 9338 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 770; /* ssaddv8qi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 751; /* sssubv4hi3 */

        case 1:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 753; /* sssubv2si3 */

        case 2:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 755; /* sssubv2hi3 */

        case 3:
          if (!
#line 9296 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 757; /* sssubv1si3 */

        case 4:
          if (!
#line 9338 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 771; /* sssubv8qi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern12 (x1))
        {
        case 0:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 758; /* minv8qi3 */

        case 1:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 760; /* minv4hi3 */

        case 2:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 762; /* minv2si3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern12 (x1))
        {
        case 0:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 759; /* maxv8qi3 */

        case 1:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 761; /* maxv4hi3 */

        case 2:
          if (!
#line 9312 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 763; /* maxv2si3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern12 (x1))
        {
        case 0:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 764; /* minuv8qi3 */

        case 1:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 766; /* minuv4hi3 */

        case 2:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 768; /* minuv2si3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern12 (x1))
        {
        case 0:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 765; /* maxuv8qi3 */

        case 1:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 767; /* maxuv4hi3 */

        case 2:
          if (!
#line 9327 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 769; /* maxuv2si3 */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 9354 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 772; /* usaddv4hi3 */

        case 1:
          if (!
#line 9354 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 774; /* usaddv8qi3 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 9354 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 773; /* ussubv4hi3 */

        case 1:
          if (!
#line 9354 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 775; /* ussubv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
