/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 102
      || GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1DImode:
      return pattern25 (x1, 
E_V1DImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern25 (x1, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern25 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern25 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, rtx_code i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || !arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_or_zero_operand (operands[0], i1)
      || !arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2
      || !cc_arith_not_operator (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !arith_operand (operands[0], i1)
      || !register_or_zero_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern126 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith11_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern141 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern150 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !arith_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x10, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case MEM:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != PLUS)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 19)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      if (!tld_symbolic_operand (operands[3], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          switch (pattern132 (x3, 
E_QImode))
            {
            case 0:
              if (!(
#line 8286 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 517; /* *tldo_stbsi */

            case 1:
              if (!(
#line 8286 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 518; /* *tldo_stbdi */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern132 (x3, 
E_HImode))
            {
            case 0:
              if (!(
#line 8296 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 519; /* *tldo_sthsi */

            case 1:
              if (!(
#line 8296 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 520; /* *tldo_sthdi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern132 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 8306 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 521; /* *tldo_stwsi */

            case 1:
              if (!(
#line 8306 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 522; /* *tldo_stwdi */

            default:
              return -1;
            }

        case E_DImode:
          if (GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[2], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !
#line 8316 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 523; /* *tldo_stx_sp64 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x2) != 102
          || GET_MODE (x2) != E_DImode
          || !arith_operand (operands[0], E_DImode))
        return -1;
      if (
#line 8799 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH64))
        return 643; /* *wrgsr_sp64 */
      if (pnum_clobbers == NULL
          || !
#line 8807 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 1;
      return 644; /* wrgsr_v8plus */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (pattern29 (x3))
            {
            case 0:
              if (
#line 5384 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return 302; /* anddi3 */
              break;

            case 1:
              return 303; /* andsi3 */

            case 2:
              if (
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 548; /* andv1si3 */
              break;

            case 3:
              if (
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 551; /* andv2hi3 */
              break;

            case 4:
              if (
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 554; /* andv4qi3 */
              break;

            case 5:
              if (
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 557; /* andv1di3 */
              break;

            case 6:
              if (
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 560; /* andv2si3 */
              break;

            case 7:
              if (
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 563; /* andv4hi3 */
              break;

            case 8:
              if (
#line 8605 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 566; /* andv8qi3 */
              break;

            default:
              break;
            }
          break;

        case NOT:
          switch (pattern54 (x3))
            {
            case 0:
              if (
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 611; /* *and_not2v1si_vis */
              break;

            case 1:
              if (
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 613; /* *and_not2v2hi_vis */
              break;

            case 2:
              if (
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 615; /* *and_not2v4qi_vis */
              break;

            case 3:
              if (
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 617; /* *and_not2v1di_vis */
              break;

            case 4:
              if (
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 619; /* *and_not2v2si_vis */
              break;

            case 5:
              if (
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 621; /* *and_not2v4hi_vis */
              break;

            case 6:
              if (
#line 8644 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 623; /* *and_not2v8qi_vis */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_SImode
          || pattern99 (x3) != 0)
        return -1;
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 6701 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && (unsigned HOST_WIDE_INT) INTVAL (operands[3]) == 0xffffffff))
        return -1;
      return 401; /* *lshrsi3_extend1 */

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 5410 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 304; /* *and_not_di_sp64 */

        case 1:
          return 305; /* *and_not_si */

        case 2:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 597; /* *and_not1v1si_vis */

        case 3:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 599; /* *and_not1v2hi_vis */

        case 4:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 601; /* *and_not1v4qi_vis */

        case 5:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 603; /* *and_not1v1di_vis */

        case 6:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 605; /* *and_not1v2si_vis */

        case 7:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 607; /* *and_not1v4hi_vis */

        case 8:
          if (!
#line 8635 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 609; /* *and_not1v8qi_vis */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (XINT (x2, 1))
        {
        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern94 (x2, 
E_SImode) != 0
                  || !(
#line 1598 "../../gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              *pnum_clobbers = 1;
              return 111; /* load_pcrel_symsi */

            case E_DImode:
              if (pattern94 (x2, 
E_DImode) != 0
                  || !(
#line 1598 "../../gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              *pnum_clobbers = 1;
              return 112; /* load_pcrel_symdi */

            default:
              return -1;
            }

        case 14:
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!symbolic_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern25 (x2, 
E_SImode) != 0
                  || !
#line 1741 "../../gcc/config/sparc/sparc.md"
(flag_pic && check_pic (1)))
                return -1;
              return 121; /* movsi_pic_gotdata_op */

            case E_DImode:
              if (pattern25 (x2, 
E_DImode) != 0
                  || !
#line 1962 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && flag_pic && check_pic (1)))
                return -1;
              return 130; /* movdi_pic_gotdata_op */

            default:
              return -1;
            }

        case 20:
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!tie_symbolic_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern25 (x2, 
E_SImode) != 0
                  || !
#line 8043 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH32))
                return -1;
              return 486; /* tie_ld32 */

            case E_DImode:
              if (pattern25 (x2, 
E_DImode) != 0
                  || !
#line 8055 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
                return -1;
              return 487; /* tie_ld64 */

            default:
              return -1;
            }

        case 24:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 102
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_V8QImode)
              || !register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V8QImode)
              || !
#line 8685 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 633; /* fpack32_vis */

        case 31:
          switch (pattern63 (x2))
            {
            case 0:
              if (!
#line 8854 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 647; /* faligndatav1di_vis */

            case 1:
              if (!
#line 8854 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 648; /* faligndatav2si_vis */

            case 2:
              if (!
#line 8854 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 649; /* faligndatav4hi_vis */

            case 3:
              if (!
#line 8854 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 650; /* faligndatav8qi_vis */

            default:
              return -1;
            }

        case 32:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_V8QImode)
              || !register_operand (operands[2], E_V8QImode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DImode)
              || !
#line 8912 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 655; /* pdist_vis */

        case 50:
          switch (pattern63 (x2))
            {
            case 0:
              if (!
#line 9105 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 712; /* bshufflev1di_vis */

            case 1:
              if (!
#line 9105 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 713; /* bshufflev2si_vis */

            case 2:
              if (!
#line 9105 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 714; /* bshufflev4hi_vis */

            case 3:
              if (!
#line 9105 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 715; /* bshufflev8qi_vis */

            default:
              return -1;
            }

        case 68:
          switch (pattern65 (x2))
            {
            case 0:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 826; /* fpcmpde8sishl */

            case 1:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 827; /* fpcmpde16sishl */

            case 2:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 828; /* fpcmpde32sishl */

            case 3:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 829; /* fpcmpde8dishl */

            case 4:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 830; /* fpcmpde16dishl */

            case 5:
              if (!(
#line 9510 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 831; /* fpcmpde32dishl */

            default:
              return -1;
            }

        case 69:
          switch (pattern65 (x2))
            {
            case 0:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 832; /* fpcmpur8sishl */

            case 1:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 833; /* fpcmpur16sishl */

            case 2:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 834; /* fpcmpur32sishl */

            case 3:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 835; /* fpcmpur8dishl */

            case 4:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 836; /* fpcmpur16dishl */

            case 5:
              if (!(
#line 9524 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 837; /* fpcmpur32dishl */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (XINT (x2, 1))
        {
        case 9:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 2061 "../../gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
            return -1;
          return 143; /* embmedany_brsum */

        case 3:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          if (
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return 433; /* *frame_blockagesi */
          if (!
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 434; /* *frame_blockagedi */

        case 26:
          if (GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[0], E_V4HImode)
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 8694 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 634; /* fexpand_vis */

        case 16:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_DImode)
              && 
#line 144 "../../gcc/config/sparc/sync.md"
(TARGET_ARCH32))
            return 843; /* atomic_loaddi_1 */
          if (!memory_operand (operands[0], E_DImode)
              || !register_or_v9_zero_operand (operands[1], E_DImode)
              || !
#line 172 "../../gcc/config/sparc/sync.md"
(TARGET_ARCH32))
            return -1;
          return 844; /* atomic_storedi_1 */

        default:
          return -1;
        }

    case 2:
      return recog_6 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern57 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 3662 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 213; /* fix_truncsfsi2 */

            case 1:
              if (!
#line 3670 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 214; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern57 (x3, 
E_DImode))
            {
            case 0:
              if (!
#line 3700 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 216; /* fix_truncsfdi2 */

            case 1:
              if (!
#line 3714 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 217; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      switch (pattern4 (x3))
        {
        case 0:
          if (!
#line 3685 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 215; /* *fix_trunctfsi2_hq */

        case 1:
          if (!
#line 3734 "../../gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 218; /* *fix_trunctfdi2_hq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      return recog_35 (x1, insn, pnum_clobbers);

    case AND:
    case IOR:
    case XOR:
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (x7))
        {
        case AND:
        case IOR:
          res = recog_33 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case AND:
        case IOR:
        case XOR:
          operands[4] = x9;
          operands[3] = x7;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x11 = XEXP (x7, 1);
          operands[2] = x11;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_CCmode:
              if (pattern146 (x6, 
E_SImode, 
E_CCmode) != 0
                  || !
#line 5544 "../../gcc/config/sparc/sparc.md"
(GET_CODE (operands[3]) == GET_CODE (operands[4])))
                return -1;
              return 316; /* *cmp_cc_arith_op_set */

            case E_CCXmode:
              if (pattern146 (x6, 
E_DImode, 
E_CCXmode) != 0
                  || !
#line 5557 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && GET_CODE (operands[3]) == GET_CODE (operands[4])))
                return -1;
              return 317; /* *cmp_ccx_arith_op_set */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      if (GET_CODE (x7) == SUBREG)
        {
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x7;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != MINUS)
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XEXP (x9, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_CCCmode:
          if (GET_MODE (x6) != E_CCCmode
              || !register_operand (operands[1], E_DImode)
              || !arith_double_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x9) != E_DImode
              || !
#line 4258 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return -1;
          return 241; /* usubvdi4_sp32 */

        case E_CCmode:
          if (pattern137 (x1, 
E_SImode, 
E_CCmode) != 0)
            return -1;
          return 251; /* *cmpsi_set */

        case E_CCXmode:
          if (pattern137 (x1, 
E_DImode, 
E_CCXmode) != 0
              || !
#line 4473 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 252; /* *cmpdi_set */

        default:
          return -1;
        }

    case PLUS:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x11 = XEXP (x7, 1);
          operands[2] = x11;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x8 = XEXP (x6, 1);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCCmode:
                  if (GET_MODE (x6) != E_CCCmode)
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_DImode:
                      if (!register_operand (operands[1], E_DImode)
                          || !arith_double_operand (operands[2], E_DImode)
                          || !register_operand (operands[0], E_DImode)
                          || GET_MODE (x9) != E_DImode
                          || !
#line 3844 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                        return -1;
                      return 220; /* uaddvdi4_sp32 */

                    case E_SImode:
                      if (pattern147 (x9, 
E_SImode) != 0)
                        return -1;
                      return 232; /* *cmp_ccc_plus_set */

                    default:
                      return -1;
                    }

                case E_CCXCmode:
                  if (pattern148 (x1, 
E_DImode, 
E_CCXCmode) != 0
                      || !
#line 4073 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 233; /* *cmp_ccxc_plus_set */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x8, 0) != 2
                  || XINT (x8, 1) != 62)
                return -1;
              x14 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XVECEXP (x8, 0, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (pattern145 (x2))
                {
                case 0:
                  if (pattern157 (x1) != 0
                      || !
#line 3882 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                    return -1;
                  return 221; /* addvdi4_sp32 */

                case 1:
                  if (!register_operand (operands[1], E_SImode)
                      || pattern158 (x1, 
E_SImode) != 0)
                    return -1;
                  return 237; /* *cmp_ccv_plus_set */

                case 2:
                  if (!register_operand (operands[1], E_DImode)
                      || pattern158 (x1, 
E_DImode) != 0
                      || !
#line 4136 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 238; /* *cmp_ccxv_plus_set */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x8, 0) != 0L)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCNZmode:
                  if (pattern148 (x1, 
E_SImode, 
E_CCNZmode) != 0)
                    return -1;
                  return 228; /* *cmp_ccnz_plus_set */

                case E_CCXNZmode:
                  if (pattern148 (x1, 
E_DImode, 
E_CCXNZmode) != 0
                      || !
#line 4033 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 229; /* *cmp_ccxnz_plus_set */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (pattern100 (x6, 
E_CCCmode, 
PLUS, 
62) != 0
              || pattern159 (x9, 
E_CCCmode, 
PLUS) != 0
              || pattern161 (x2) != 0)
            return -1;
          x16 = XEXP (x10, 1);
          operands[2] = x16;
          if (!arith_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x9) != E_SImode
              || pattern163 (x1) != 0)
            return -1;
          return 239; /* *cmp_ccv_plus_sltu_set */

        default:
          return -1;
        }

    case MINUS:
      return recog_36 (x1, insn, pnum_clobbers);

    case MULT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != MULT
          || GET_MODE (x9) != E_SImode
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x6) != E_CCmode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!arith_operand (operands[1], E_SImode)
          || pattern87 (x1) != 0
          || !
#line 4633 "../../gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_SPARCLITE || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      return 263; /* *cmp_mul_set */

    case DIV:
      if (pnum_clobbers == NULL
          || pattern88 (x1, 
DIV) != 0
          || !
#line 5240 "../../gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      *pnum_clobbers = 1;
      return 294; /* *cmp_sdiv_cc_set */

    case UDIV:
      if (pattern88 (x1, 
UDIV) != 0
          || !
#line 5329 "../../gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      return 298; /* *cmp_udiv_cc_set */

    case NOT:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case XOR:
          if (XWINT (x8, 0) != 0L)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != NOT)
            return -1;
          x12 = XEXP (x9, 0);
          if (GET_CODE (x12) != XOR)
            return -1;
          x17 = XEXP (x10, 0);
          operands[1] = x17;
          x16 = XEXP (x10, 1);
          operands[2] = x16;
          x18 = XEXP (x12, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          x19 = XEXP (x12, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_CCmode:
              if (pattern150 (x1, 
E_SImode, 
E_CCmode) != 0)
                return -1;
              return 320; /* *cmp_cc_xor_not_set */

            case E_CCXmode:
              if (pattern150 (x1, 
E_DImode, 
E_CCXmode) != 0
                  || !
#line 5601 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 321; /* *cmp_ccx_xor_not_set */

            default:
              return -1;
            }

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          switch (XWINT (x8, 0))
            {
            case -1L:
              x9 = XEXP (x4, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCCmode:
                  if (GET_MODE (x6) != E_CCCmode)
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_DImode:
                      if (!register_operand (operands[1], E_DImode)
                          || !register_operand (operands[0], E_DImode)
                          || GET_MODE (x9) != E_DImode
                          || !
#line 5734 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                        return -1;
                      return 327; /* unegvdi3_sp32 */

                    case E_SImode:
                      if (!register_operand (operands[1], E_SImode)
                          || !register_operand (operands[0], E_SImode)
                          || GET_MODE (x9) != E_SImode)
                        return -1;
                      return 335; /* *cmp_ccc_neg_set */

                    default:
                      return -1;
                    }

                case E_CCXCmode:
                  if (pattern143 (x1, 
E_DImode, 
E_CCXCmode) != 0
                      || !
#line 5874 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 336; /* *cmp_ccxc_neg_set */

                default:
                  return -1;
                }

            case 0L:
              x9 = XEXP (x4, 1);
              if (GET_CODE (x9) != NOT)
                return -1;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCmode:
                  if (pattern144 (x1, 
E_SImode, 
E_CCmode) != 0)
                    return -1;
                  return 347; /* *cmp_cc_set_not */

                case E_CCXmode:
                  if (pattern144 (x1, 
E_DImode, 
E_CCXmode) != 0
                      || !
#line 5990 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 348; /* *cmp_ccx_set_not */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != NEG)
        return -1;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x8 = XEXP (x6, 1);
          switch (GET_CODE (x8))
            {
            case UNSPEC:
              if (XVECLEN (x8, 0) != 1
                  || XINT (x8, 1) != 64)
                return -1;
              x14 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              switch (pattern145 (x2))
                {
                case 0:
                  if (pattern153 (x1, 
E_DImode) != 0
                      || !
#line 5763 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                    return -1;
                  return 328; /* negvdi3_sp32 */

                case 1:
                  if (pattern153 (x1, 
E_SImode) != 0)
                    return -1;
                  return 340; /* *cmp_ccv_neg_set */

                case 2:
                  if (pattern153 (x1, 
E_DImode) != 0
                      || !
#line 5926 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 341; /* *cmp_ccxv_neg_set */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x8, 0) != 0L)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCNZmode:
                  if (pattern143 (x1, 
E_SImode, 
E_CCNZmode) != 0)
                    return -1;
                  return 333; /* *cmp_ccnz_neg_set */

                case E_CCXNZmode:
                  if (pattern143 (x1, 
E_DImode, 
E_CCXNZmode) != 0
                      || !
#line 5854 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 334; /* *cmp_ccxnz_neg_set */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (pattern122 (x16) != 0)
            return -1;
          x8 = XEXP (x6, 1);
          if (pattern123 (x8, 
E_SImode, 
64, 
1) != 0)
            return -1;
          x14 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x20 = XEXP (x14, 1);
          if (GET_CODE (x20) != LTU
              || GET_MODE (x20) != E_SImode)
            return -1;
          x21 = XEXP (x20, 0);
          if (GET_CODE (x21) != REG
              || REGNO (x21) != 100
              || GET_MODE (x21) != E_CCCmode)
            return -1;
          x22 = XEXP (x20, 1);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XEXP (x9, 0);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != E_SImode)
            return -1;
          x19 = XEXP (x12, 1);
          if (GET_CODE (x19) != LTU
              || GET_MODE (x19) != E_SImode)
            return -1;
          x23 = XEXP (x19, 0);
          if (GET_CODE (x23) != REG
              || REGNO (x23) != 100
              || GET_MODE (x23) != E_CCCmode)
            return -1;
          x24 = XEXP (x19, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern161 (x2) != 0
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x9) != E_SImode)
            return -1;
          x25 = XEXP (x14, 0);
          if (!rtx_equal_p (x25, operands[1]))
            return -1;
          x18 = XEXP (x12, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          return 342; /* *cmp_ccv_neg_sltu_set */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x11 = XEXP (x7, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != ASHIFT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x13 = XEXP (x9, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_MODE (x3) != E_CCNZmode
          || GET_MODE (x6) != E_CCNZmode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      return 392; /* *cmp_ccnz_set_ashift_1 */

    default:
      return -1;
    }
}
