/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern15 (x1, pnum_clobbers, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern15 (x1, pnum_clobbers, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  return pattern36 (x6); /* [-1, 1] */
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!arith_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[3] = x2;
  if (!imm2_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern64 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern64 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!text_segment_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1, rtx_code i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != LTU
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 2
      || XINT (x7, 1) != i3
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != i2
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x7, 0, 1);
  if (GET_CODE (x9) != LTU
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LTU
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CCCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_or_zero_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  return pattern147 (x6, 
i1); /* [-1, 0] */
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_DImode)
      || !arith_double_operand (operands[2], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (icc_comparison_operator (operands[0], E_VOIDmode))
    {
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) == REG
          && REGNO (x4) == 100)
        {
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) == PC)
            {
              x6 = XEXP (x2, 1);
              switch (GET_CODE (x6))
                {
                case LABEL_REF:
                  x7 = XEXP (x2, 2);
                  if (GET_CODE (x7) == PC)
                    {
                      x8 = XEXP (x6, 0);
                      operands[1] = x8;
                      return 101; /* *normal_branch */
                    }
                  break;

                case PC:
                  x7 = XEXP (x2, 2);
                  if (GET_CODE (x7) == LABEL_REF)
                    {
                      x9 = XEXP (x7, 0);
                      operands[1] = x9;
                      return 102; /* *inverted_branch */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  if (!v9_register_comparison_operator (operands[0], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x2, 2);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x9 = XEXP (x7, 0);
  operands[2] = x9;
  if (!
#line 1573 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
    return -1;
  return 110; /* *inverted_int_branch_sp64 */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern60 (x3))
        {
        case 0:
          if (memory_operand (operands[1], E_HImode))
            return 174; /* *zero_extendhisi2_insn */
          if (input_operand (operands[1], E_QImode)
              && 
#line 3066 "../../gcc/config/sparc/sparc.md"
(GET_CODE (operands[1]) != CONST_INT))
            return 176; /* *zero_extendqisi2_insn */
          break;

        case 1:
          if (input_operand (operands[1], E_QImode)
              && 
#line 3049 "../../gcc/config/sparc/sparc.md"
(GET_CODE (operands[1]) != CONST_INT))
            return 175; /* *zero_extendqihi2_insn */
          break;

        case 2:
          if (input_operand (operands[1], E_QImode)
              && 
#line 3083 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && GET_CODE (operands[1]) != CONST_INT))
            return 177; /* *zero_extendqidi2_insn */
          if (memory_operand (operands[1], E_HImode)
              && 
#line 3117 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return 178; /* *zero_extendhidi2_insn */
          if (input_operand (operands[1], E_SImode)
              && 
#line 3134 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && GET_CODE (operands[1]) != CONST_INT))
            return 179; /* *zero_extendsidi2_insn_sp64 */
          if (register_operand (operands[1], E_SImode)
              && 
#line 3147 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return 180; /* *zero_extendsidi2_insn_sp32 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != MEM)
        return -1;
      switch (pattern62 (x3))
        {
        case 0:
          if (!(
#line 8104 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 494; /* *tldo_ldub1si */

        case 1:
          if (!(
#line 8104 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 495; /* *tldo_ldub1di */

        case 2:
          if (!(
#line 8117 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 496; /* *tldo_ldub2si */

        case 3:
          if (!(
#line 8117 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 497; /* *tldo_ldub2di */

        case 4:
          if (!(
#line 8191 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 506; /* *tldo_lduh1si */

        case 5:
          if (!(
#line 8191 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 507; /* *tldo_lduh1di */

        case 6:
          if (!
#line 8154 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 502; /* *tldo_ldub3_sp64 */

        case 7:
          if (!
#line 8216 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 510; /* *tldo_lduh2_sp64 */

        case 8:
          if (!
#line 8252 "../../gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 514; /* *tldo_lduw1_sp64 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern51 (x4, 
PLUS) != 0
          || pattern99 (x3) != 0
          || !
#line 3917 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return -1;
      return 222; /* *addx_extend_sp32 */

    case MINUS:
      if (pattern51 (x4, 
MINUS) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_or_zero_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!arith_operand (operands[2], E_SImode)
          || !
#line 4332 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return -1;
      return 243; /* *subx_extend_sp32 */

    case LSHIFTRT:
      if (pattern50 (x3) != 0
          || !
#line 6685 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 400; /* *lshrsi3_extend0 */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
      switch (pattern16 (x3, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 13; /* *neg_snesisi_zero */

        case 1:
          if (
#line 864 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_SUBXC))
            return 19; /* *neg_snedisi_zero */
          if (pnum_clobbers == NULL
              || !
#line 879 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC))
            return -1;
          *pnum_clobbers = 1;
          return 21; /* *neg_snedisi_zero_subxc */

        case 2:
          if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 14; /* *neg_snesidi_zero */

        case 3:
          if ((
#line 864 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_SUBXC) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return 20; /* *neg_snedidi_zero */
          if (pnum_clobbers == NULL
              || !(
#line 879 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          *pnum_clobbers = 1;
          return 22; /* *neg_snedidi_zero_subxc */

        default:
          return -1;
        }

    case EQ:
      switch (pattern16 (x3, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 25; /* *neg_seqsisi_zero */

        case 1:
          if (!
#line 931 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 29; /* *neg_seqdisi_zero */

        case 2:
          if (!
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 26; /* *neg_seqsidi_zero */

        case 3:
          if (!
#line 931 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 30; /* *neg_seqdidi_zero */

        default:
          return -1;
        }

    case GEU:
      switch (pattern18 (x3))
        {
        case 0:
          if (!
#line 1133 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
            return -1;
          return 57; /* *neg_sgeusi */

        case 1:
          if (!(
#line 1133 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 58; /* *neg_sgeudi */

        default:
          return -1;
        }

    case LTU:
      switch (pattern18 (x3))
        {
        case 0:
          if (
#line 1209 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
            return 72; /* *neg_sltusi */
          if (!
#line 1289 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[1]) == CCXmode || GET_MODE (operands[1]) == CCXCmode)))
            return -1;
          return 89; /* *neg_sltusi_subxc */

        case 1:
          if ((
#line 1209 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return 73; /* *neg_sltudi */
          if (!(
#line 1289 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[1]) == CCXmode || GET_MODE (operands[1]) == CCXCmode)) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 90; /* *neg_sltudi_subxc */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case LTU:
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!icc_register_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern93 (x3, 
E_SImode) != 0)
                return -1;
              if (arith_operand (operands[1], E_SImode)
                  && 
#line 1236 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
                return 77; /* *neg_plus_sltusi */
              if (!register_operand (operands[1], E_SImode)
                  || !
#line 1309 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)))
                return -1;
              return 93; /* *neg_plus_sltusi_subxc */

            case E_DImode:
              if (pattern93 (x3, 
E_DImode) != 0)
                return -1;
              if (arith_operand (operands[1], E_DImode)
                  && (
#line 1236 "../../gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return 78; /* *neg_plus_sltudi */
              if (!register_operand (operands[1], E_DImode)
                  || !(
#line 1309 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)) && 
#line 215 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 94; /* *neg_plus_sltudi_subxc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern30 (x3, 
E_SFmode) != 0
                  || !
#line 9363 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 776; /* *naddsf3 */

            case E_DFmode:
              if (pattern30 (x3, 
E_DFmode) != 0
                  || !
#line 9371 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 777; /* *nadddf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 5714 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            {
              *pnum_clobbers = 1;
              return 326; /* negdi2_sp32 */
            }
          if (!
#line 5789 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 329; /* *negdi2_sp64 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 330; /* negsi2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 6259 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return 374; /* *negtf2_hq */
          if (!
#line 6266 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD))
            return -1;
          return 375; /* *negtf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 6307 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9))
            return 376; /* *negdf2_notv9 */
          if (!
#line 6342 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_V9))
            return -1;
          return 377; /* *negdf2_v9 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6350 "../../gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 378; /* negsf2 */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XEXP (x4, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern82 (x3, 
E_DFmode) != 0
                  || !
#line 6134 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 362; /* *nfmadf4 */

            case E_SFmode:
              if (pattern82 (x3, 
E_SFmode) != 0
                  || !
#line 6170 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 366; /* *nfmasf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern83 (x3, 
E_DFmode) != 0
                  || !
#line 6143 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 363; /* *nfmsdf4 */

            case E_SFmode:
              if (pattern83 (x3, 
E_SFmode) != 0
                  || !
#line 6179 "../../gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 367; /* *nfmssf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 56)
        return -1;
      x11 = XVECEXP (x4, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[2] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern84 (x3, 
E_SFmode) != 0
              || !
#line 9447 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 785; /* fnhaddsf_vis */

        case E_DFmode:
          if (pattern84 (x3, 
E_DFmode) != 0
              || !
#line 9456 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 786; /* fnhadddf_vis */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (pattern33 (x3))
    {
    case 0:
      return 399; /* lshrsi3 */

    case 1:
      if (register_operand (operands[1], E_DImode)
          && 
#line 6743 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return 403; /* *lshrdi3_sp64 */
      if (pnum_clobbers != NULL
          && arith_operand (operands[1], E_DImode)
          && 
#line 6756 "../../gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
        {
          *pnum_clobbers = 1;
          return 404; /* lshrdi3_v8plus */
        }
      break;

    case 2:
      if (
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
        return 737; /* vlshrv4hi3 */
      break;

    case 3:
      if (
#line 9234 "../../gcc/config/sparc/sparc.md"
(TARGET_VIS3))
        return 741; /* vlshrv2si3 */
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_SImode)
      || GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (!small_int_operand (x6, E_SImode))
    return -1;
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      operands[2] = x6;
      if (!
#line 6780 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && (unsigned HOST_WIDE_INT) INTVAL (operands[2]) < 32))
        return -1;
      return 406; /* *sparc.md:6775 */

    case LSHIFTRT:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!small_int_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x6;
      if (!
#line 6808 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2]) >= 32
   && (unsigned HOST_WIDE_INT) INTVAL (operands[3]) < 32
   && (unsigned HOST_WIDE_INT) (INTVAL (operands[2]) + INTVAL (operands[3])) < 64))
        return -1;
      return 408; /* *sparc.md:6803 */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) == AND)
    {
      res = recog_32 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  switch (GET_CODE (x7))
    {
    case AND:
    case IOR:
      operands[4] = x7;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != NOT)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x7, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      x13 = XEXP (x2, 0);
      switch (GET_MODE (x13))
        {
        case E_CCmode:
          if (pattern154 (x1, 
E_SImode, 
E_CCmode) != 0
              || !
#line 5634 "../../gcc/config/sparc/sparc.md"
(GET_CODE (operands[3]) == GET_CODE (operands[4])))
            return -1;
          return 324; /* *cmp_cc_arith_op_not_set */

        case E_CCXmode:
          if (pattern154 (x1, 
E_DImode, 
E_CCXmode) != 0
              || !
#line 5647 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && GET_CODE (operands[3]) == GET_CODE (operands[4])))
            return -1;
          return 325; /* *cmp_ccx_arith_op_not_set */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 8)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x5, 0, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern138 (x5, 
E_SImode) != 0)
        return -1;
      if (
#line 216 "../../gcc/config/sparc/sync.md"
(TARGET_V9 && (SImode != DImode || TARGET_ARCH64)))
        return 845; /* *atomic_compare_and_swapsi_1 */
      if (!
#line 228 "../../gcc/config/sparc/sync.md"
(TARGET_LEON3))
        return -1;
      return 847; /* atomic_compare_and_swap_leon3_1 */

    case E_DImode:
      if (pattern138 (x5, 
E_DImode) != 0)
        return -1;
      if ((
#line 216 "../../gcc/config/sparc/sync.md"
(TARGET_V9 && (DImode != DImode || TARGET_ARCH64)) && 
#line 23 "../../gcc/config/sparc/sync.md"
(TARGET_ARCH64 || TARGET_V8PLUS)))
        return 846; /* *atomic_compare_and_swapdi_1 */
      if (!
#line 249 "../../gcc/config/sparc/sync.md"
(TARGET_V8PLUS))
        return -1;
      return 848; /* *atomic_compare_and_swapdi_v8plus */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      if (XWINT (x4, 0) != 0L
          || !memory_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return NULL;
      if (
#line 7638 "../../gcc/config/sparc/sparc.md"
(TARGET_V9
   && mems_ok_for_ldd_peep (operands[0], operands[1], NULL_RTX)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_1 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 7650 "../../gcc/config/sparc/sparc.md"
(TARGET_V9
   && mems_ok_for_ldd_peep (operands[1], operands[0], NULL_RTX)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_2 (insn, operands);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode))
            {
              if (memory_operand (operands[1], E_SImode))
                {
                  x6 = XEXP (x3, 0);
                  operands[2] = x6;
                  if (register_operand (operands[2], E_SImode))
                    {
                      x5 = XEXP (x3, 1);
                      operands[3] = x5;
                      if (memory_operand (operands[3], E_SImode)
                          && 
#line 7662 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[0], operands[2]) 
   && mems_ok_for_ldd_peep (operands[1], operands[3], operands[0])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_3 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
              if (register_operand (operands[1], E_SImode)
                  && pattern89 (x3, 
E_SImode, 
E_CCmode) == 0
                  && 
#line 7771 "../../gcc/config/sparc/sparc.md"
((rtx_equal_p (operands[2], operands[0])
    || rtx_equal_p (operands[2], operands[1]))
    && !SPARC_FP_REG_P (REGNO (operands[0]))
    && !SPARC_FP_REG_P (REGNO (operands[1]))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_11 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (memory_operand (operands[2], E_SImode)
              && memory_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (register_operand (operands[3], E_SImode)
                  && 
#line 7675 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[1], operands[3]) 
   && mems_ok_for_ldd_peep (operands[0], operands[2], NULL_RTX)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_4 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (register_operand (operands[2], E_SImode)
              && register_operand (operands[0], E_SImode)
              && memory_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SImode)
                  && 
#line 7714 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[2], operands[0]) 
  && mems_ok_for_ldd_peep (operands[3], operands[1], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SImode)
              || !memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 7727 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[3], operands[1]) 
  && mems_ok_for_ldd_peep (operands[2], operands[0], NULL_RTX)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_SFmode:
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && memory_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SFmode)
                  && 
#line 7688 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[0], operands[2]) 
   && mems_ok_for_ldd_peep (operands[1], operands[3], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_5 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (memory_operand (operands[2], E_SFmode)
              && memory_operand (operands[0], E_SFmode)
              && register_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (register_operand (operands[3], E_SFmode)
                  && 
#line 7701 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[1], operands[3]) 
  && mems_ok_for_ldd_peep (operands[0], operands[2], NULL_RTX)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_6 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && memory_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SFmode)
                  && 
#line 7740 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[2], operands[0]) 
  && mems_ok_for_ldd_peep (operands[3], operands[1], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_9 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SFmode)
              || !memory_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SFmode)
              || !
#line 7753 "../../gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[3], operands[1]) 
  && mems_ok_for_ldd_peep (operands[2], operands[0], NULL_RTX)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_10 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || pattern89 (x3, 
E_DImode, 
E_CCXmode) != 0
              || !
#line 7786 "../../gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (rtx_equal_p (operands[2], operands[0])
       || rtx_equal_p (operands[2], operands[1]))
   && !SPARC_FP_REG_P (REGNO (operands[0]))
   && !SPARC_FP_REG_P (REGNO (operands[1]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_12 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 15
          || GET_MODE (x4) != E_BLKmode)
        return NULL;
      x7 = XVECEXP (x4, 0, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_SImode))
        return NULL;
      x8 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x8, operands[0]))
        return NULL;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 15
          || GET_MODE (x5) != E_BLKmode)
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      x9 = XVECEXP (x5, 0, 1);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_SImode))
        return NULL;
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    default:
      return NULL;
    }
}
